import { IGraph } from "../types/IGraph";
import { IVertex } from "../types/IVertex";
import { IEdge } from "../types/IEdge";
/**
 * @classdesc
 * Finder of SCC
 */
export declare class SccBuilder {
    /**
     * Finds strongly connected components
     * @param graph
     * @returns {IGraph[]}
     */
    static findComponents(graph: IGraph<IVertex, IEdge>): IGraph<IVertex, IEdge>[];
    private readonly _accessibilityMatrix;
    private readonly _graph;
    private readonly _vertices;
    private constructor();
    static buildAdjacencyMatrix(graph: IGraph<IVertex, IEdge>): number[][];
    private buildComponents;
}
